datablock AudioProfile(TheBaxeDrawSound)
{
	filename    = "./TheBaxeDraw.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(TheBaxeHitSound)
{
	filename    = "./swordHitQuieter.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(TheBaxeSwingSound)
{
	filename    = "./TheBaxeSwing.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ParticleData(TheBaxeExplosionParticle)
{
	dragCoefficient = 2;
	gravityCoefficient = 1.0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin = -90;
	spinRandomMax = 90;
	lifetimeMS = 150;
	textureName = "base/data/particles/chunk";
	colors[0] = "0.7 0.7 0.9 0.9";
	colors[1] = "0.9 0.9 0.9 0.0";
	sizes[0] = 0.4;
	sizes[1] = 0.1;
};

datablock ParticleEmitterData(TheBaxeExplosionEmitter)
{
	ejectionPeriodMS = 7;
	periodVarianceMS = 0;
	ejectionVelocity = 8;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 60;
	phiReferenceVel  = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "TheBaxeExplosionParticle";
};

datablock ExplosionData(TheBaxeExplosion)
{
	lifeTimeMS = 200;
	soundProfile = TheBaxeHitSound;
	particleEmitter = TheBaxeExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer = true;
	explosionScale = "1 1 1";
};

AddDamageType("TheBaxe", '<bitmap:add-ons/Weapon_The_Baxe/CI_TheBaxe> %1', '%2 <bitmap:add-ons/Weapon_The_Baxe/CI_TheBaxe> %1',0.75,1);

datablock ProjectileData(TheBaxeProjectile)
{
	projectileShapeName = "./bass axe_proj.dts";
	directDamage = 8;
	directDamageType = $DamageType::TheBaxe;
	radiusDamageType = $DamageType::TheBaxe;
	brickExplosionRadius = 0;
	brickExplosionImpact = true;
	brickExplosionForce = 1;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;
	impactImpulse = 50;
	verticalImpulse = 50;
	explosion = TheBaxeExplosion;
	explodeOnPlayerImpact = true;
	explodeondeath = false;
	muzzleVelocity = 100;
	velInheritFactor = 0;
	armingDelay = 000;
	lifetime = 92;
	fadeDelay = 92;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = true;
	gravityMod = 0;
	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";
};

datablock ItemData(TheBaxeItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./bass axe.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "The Baxe";
	iconName = "./icon_TheBaxe";
	doColorShift = false;
	colorShiftColor = "0.5 0.5 0.5 1.000";
	image = TheBaxeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(TheBaxeImage)
{
	shapeFile = "./bass axe.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = TheBaxeItem;
	ammo = "";
	projectile = TheBaxeProjectile;
	projectileType = Projectile;
	melee = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = TheBaxeItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.01;
	stateSound[0] = TheBaxeDrawSound;

	stateName[1] = "Ready";
	stateScript[1] = "onReady";
	stateTransitionOnTriggerDown[1] = "Windup";

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.1;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = TheBaxeSwingSound;

	stateName[3] = "Windup";
	stateTimeoutValue[3] = 0.1;
	stateScript[3] = "onWindup";
	stateTransitionOnTimeout[3] = "Fire";
	stateSound[3] = TheBaxeSwingSound;

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTimeout[4] = "Ready";
};

function TheBaxeImage::onWindUp(%this, %obj, %slot)
{
	%obj.playThread(2, shiftAway);
	%obj.playThread(0, shiftAway);
	%obj.playThread(3, rotccw);

	%projectile = TheBaxeProjectile;
	%spread = 0.0000;
	%shellcount = 1;
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
		MissionCleanup.add(%p);
	}

	%projectile = TheBaxeProjectile;
	%spread = 5.0000;
	%shellcount = 6;
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
		MissionCleanup.add(%p);
	}
}

function TheBaxeImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(2, shiftTo);
	%obj.playThread(0, rotcw);
	%obj.playThread(3, plant);
	%obj.spawnExplosion(TheBaxeRecoilProjectile,"1 1 1");

	%projectile = TheBaxeProjectile;
	%spread = 0.0000;
	%shellcount = 1;
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
		MissionCleanup.add(%p);
	}

	%projectile = TheBaxeProjectile;
	%spread = 5.0000;
	%shellcount = 6;
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
		MissionCleanup.add(%p);
	}
}

function TheBaxeImage::onReady(%this, %obj, %slot)
{	
	%obj.playthread(2, rotcw);
}

function TheBaxeImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}